--- asterisk-1.6.1.12/channels/chan_skinny.c	2009-09-02 17:30:37.000000000 -0400
+++ asterisk-1.6.1.12/channels/chan_skinny.c_AZ	2010-01-26 03:20:02.000000000 -0500
@@ -1802,6 +1802,7 @@
 
 static int skinny_unregister(struct skinny_req *req, struct skinnysession *s)
 {
+	struct skinny_subchannel *sub = NULL;
 	struct skinny_device *d;
 	struct skinny_line *l;
 	struct skinny_speeddial *sd;
@@ -1809,6 +1810,18 @@
 	d = s->device;
 
 	if (d) {
+		sub = find_subchannel_by_instance_reference(d, d->lastlineinstance, d->lastcallreference);
+		if (sub) {			
+			if (sub->owner) {
+				sub->alreadygone = 1;
+				ast_queue_hangup(sub->owner);
+			} else {
+				AST_LIST_TRAVERSE(&d->lines, l, list) {
+					ast_log(LOG_WARNING, "arifzaman:: Skinny(%s@%s-%d) channel already destroyed\n",
+						l->name, d->name, sub->callid);
+				}
+			}
+		}
 		d->session = NULL;
 		d->registered = 0;
 
